/* --- Copyright University of Birmingham 1996. All rights reserved. ------
 > File:            $poplocal/local/auto/rc_mouse_coords.p
 > Purpose:         Like rc_mouse_draw(true, N) but draws nothing
 > Author:          Aaron Sloman, Jun 27 1996
 > Documentation:	HELP RC_MOUSE_COORDS
 > Related Files:
 */

/*
rc_destroy();
rc_start();
rc_mouse_coords(1) =>
*/


uses rc_mouse;

section;
define rc_mouse_coords( stop_button) -> list;
	;;; Draw a picture using the mouse. If listpoints is true, then
	;;; return a list of points. Use "rubber banding effect"

	lvars listpoints, list = [], stop_button;

	define lconstant first(x, y, data, item);
		lvars x, y, data, item;
		rc_conspoint(x,y) :: list -> list;
	enddefine;

	define lconstant other(x, y, data, item);
		lvars x,y,data, item;
		returnif(item == "button" and data < 0);

		if item == "button" then
			rc_conspoint(x,y) :: list -> list;
		endif;
	enddefine;

	define lconstant exit(/*x, y,*/ data, item);
		lvars data, item;
		-> ->;  ;;; remove x and y from stack
		item == "button" and data == stop_button
	enddefine;

	rc_mouse_do(first, other, exit);
    ncrev(list) -> list;

enddefine;

endsection;
